// protocol used to talk between exe and it's launcher

#ifndef __CLIENTSERVER_H
#define __CLIENTSERVER_H

#include <w32std.h>

// names
_LIT(KServerName,   "PicodriveNServ");
_LIT(KServerWGName, "Picosmall"); // window group name
_LIT(KClientName,   "PicodriveN");
_LIT(KClientFind,   "PicodriveN*"); // client search mask (for TFindLibrary)


// opcodes used in message passing between client and server
enum TPicoServRqst {
	PicoMsgLoadState,
	PicoMsgSaveState,
	PicoMsgLoadROM,
	PicoMsgResume,
	PicoMsgReset,
	PicoMsgKeys,
	PicoMsgPause,
	PicoMsgQuit,
	PicoMsgConfigChange,	// launcher -> emu
	PicoMsgRetrieveConfig,  // emu -> launcher
	kDefaultMessageSlots // this is how many messages we need :)
};


// event messages to launcher
enum TPicoLauncherEvents {
	EEventKeyCfgDone = EEventUser + 1,
	EEventGamePaused,
};


// configuration data to be sent between server and client
struct TPicoConfig {
	enum TPicoScreenRotation {
		PRot0,
		PRot90,
		PRot180,
		PRot270
	};
	enum TPicoScreenMode {
		PMCenter,
		PMFit
	};
	enum TPicoFrameSkip {
		PFSkipAuto = -1,
		PFSkip0
	};
	TInt32				iScreenRotation;
	TInt32				iScreenMode;
	TUint32				iFlags;   // LSb->MSb: use_sram, show_fps, enable_sound, sound_rate(3bits)
	TUint32				iPicoOpt; // enable_ym2612&dac, enable_sn76496, enable_z80, stereo_sound
	TInt32				iFrameskip;
	TUint32				iKeyBinds[32]; // enough?
	TUint32				iAreaBinds[19];
};


#endif	// __CLIENTSERVER_H
