@ assembly "optimized" version of some funtions from draw.c
@ this is highly specialized, be careful if changing related C code!

@ (c) Copyright 2006, notaz
@ All Rights Reserved


@ struct TileStrip
@ {
@   int nametab; // 0x00
@   int line;    // 0x04
@   int hscroll; // 0x08
@   int xmask;   // 0x0C
@   int high;    // 0x10
@ };

.extern Pico
.extern HighCol
.extern WrongPri


.global DrawStrip @ struct TileStrip *ts

DrawStrip:
    stmfd   sp!, {r4-r10,lr}

    ldr     r1, [r0, #8]   @ ts->hscroll
    mvn     r9, #0         @ r9=blank=-1
    rsb     r8, r1, #0
    mov     r8, r8, asr #3 @ r8=tilex=(-ts->hscroll)>>3

    ldr     r2, [r0, #4]
    and     r2, r2, #7
    mov     r10,r2, lsl #1 @ r10=ty=(ts->line&7)<<1;

    sub     r1, r1, #1
    and     r1, r1, #7
    add     r7, r1, #1     @ r7=dx=((ts->hscroll-1)&7)+1

    @ cache some stuff to avoid mem access
    ldr     r5, [r0, #0x0C] @ r5=ts->xmask
    ldr     r6, [r0, #0x10] @ r6=ts->high (bool), also bit2=1 if WrongPri=1
    ldr     r11,=(HighCol+48) @ r11=HighCol+24 (halfwords)
    ldr     r12,[r0]
    mov     r12,r12, lsl #1 @ r12=(ts->nametab<<1) (halfword compliant)
    ldr     lr, =(Pico+0x10000) @ lr=Pico.vram

.dsloop: @ 40 times
    and     r1, r5, r8
    add     r1, lr, r1, lsl #1 @ Pico.vram+((tilex&ts->xmask) as halfwords)
    ldrh    r1, [r1, r12]      @ r1=code (int, but from unsigned, no sign extend)

    cmp     r1, r9
    beq     .dsloop_continue @ if (code==blank) continue;

    and     r2, r6, #1
    teq     r2, r1, asr #15
    orrne   r6, r6, #2       @ mark WrongPri
    bne     .dsloop_continue @ if ((code>>15)!=ts->high) { WrongPri=1; continue; }

    movs    r2, r1, lsl #20 @ if (code&0x1000)
    mov     r2, r2, lsl #1
    mov     r2, r2, lsr #17 @ r2=addr=(code&0x7ff)<<4;
    subcs   r2, r2, r10
    addcs   r2, r2, #14     @ addr+=14-ty;
    addcc   r2, r2, r10     @ addr+=ty

    add     r3, lr, #0x12000
    add     r3, r3, #0x00100 @ r3=Pico.cram
    mov     r4, r1, asr #9
    and     r4, r4, #0x30
    add     r3, r3, r4, lsl #1 @ r3=pal=Pico.cram+((code>>9)&0x30);

    ldr     r2, [lr, r2, lsl #1] @ pack=*(unsigned int *)(Pico.vram+addr); // Get 8 pixels
    tst     r2, r2
    moveq   r9, r1          @ if (zero) blank=code;
    beq     .dsloop_continue

    tst     r1, #0x0800
    add     r1, r11, r7, lsl #1 @ r1=pdest (halfwords)
    mov     r0, #0x1E
    beq     .DrawStrip_TileNorm

    @ TileFlip (r1=pdest, r2=pixels8, r3=pal) r4: scratch, r0: helper pattern
    ands    r4, r0, r2, lsr #15 @ #0x000f0000
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1]
    ands    r4, r0, r2, lsr #19 @ #0x00f00000
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1,#2]
    ands    r4, r0, r2, lsr #23 @ #0x0f000000
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1,#4]
    ands    r4, r0, r2, lsr #27 @ #0xf0000000
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1,#6]
    ands    r4, r0, r2, lsl #1  @ #0x0000000f
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1,#8]
    ands    r4, r0, r2, lsr #3  @ #0x000000f0
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1,#10]
    ands    r4, r0, r2, lsr #7  @ #0x00000f00
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1,#12]
    ands    r4, r0, r2, lsr #11 @ #0x0000f000
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1,#14]
    b       .dsloop_continue

.DrawStrip_TileNorm:
    ands    r4, r0, r2, lsr #11 @ #0x0000f000
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1]
    ands    r4, r0, r2, lsr #7  @ #0x00000f00
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1,#2]
    ands    r4, r0, r2, lsr #3  @ #0x000000f0
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1,#4]
    ands    r4, r0, r2, lsl #1  @ #0x0000000f
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1,#6]
    ands    r4, r0, r2, lsr #27 @ #0xf0000000
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1,#8]
    ands    r4, r0, r2, lsr #23 @ #0x0f000000
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1,#10]
    ands    r4, r0, r2, lsr #19 @ #0x00f00000
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1,#12]
    ands    r4, r0, r2, lsr #15 @ #0x000f0000
    ldrneh  r4, [r3, r4]
    strneh  r4, [r1,#14]

.dsloop_continue:
    add     r7, r7, #8
    cmp     r7, #328
    add     r8, r8, #1
    blt     .dsloop

    mov     r0, r6, lsr #1
    ldr     r1, =WrongPri
    str     r0, [r1]

    ldmfd   sp!, {r4-r10,lr}
    bx      lr



.global BackFill @ int reg7

BackFill:
    stmfd   sp!, {r4-r9,lr}

    ldr     lr, =(HighCol+64)   @ r11=HighCol+32 (halfwords)

    mov     r0, r0, lsl #26
    ldr     r1, =(Pico+0x22100) @ r1=Pico.cram
    add     r0, r1, r0, lsr #25 @ halfwords
    ldrh    r0, [r0]            @ back=Pico.cram[reg7&0x3f];
    orr     r0, r0, r0, lsl #16

    mov     r1, r0 @ 25 opcodes wasted?
    mov     r2, r0
    mov     r3, r0
    mov     r4, r0
    mov     r5, r0
    mov     r6, r0
    mov     r7, r0
    mov     r8, r0
    mov     r9, r0

    @ go go go!
    stmia   lr!, {r0-r9} @ 10*16
    stmia   lr!, {r0-r9}
    stmia   lr!, {r0-r9}
    stmia   lr!, {r0-r9}
    stmia   lr!, {r0-r9}
    stmia   lr!, {r0-r9}
    stmia   lr!, {r0-r9}
    stmia   lr!, {r0-r9}
    stmia   lr!, {r0-r9}
    stmia   lr!, {r0-r9}
    stmia   lr!, {r0-r9}
    stmia   lr!, {r0-r9}
    stmia   lr!, {r0-r9}
    stmia   lr!, {r0-r9}
    stmia   lr!, {r0-r9}
    stmia   lr!, {r0-r9}

    ldmfd   sp!, {r4-r9,r12}
    bx      r12

